<template>
  <label>Secrets:</label>
  <lull-datatable
    class="w-full"
    :loading="loading"
    :filter="false"
    :data="secrets"
  >
    <lull-datatableColumn id="value" label="Value" />
    <lull-datatableColumn id="description" label="Description" />
    <lull-datatableColumn id="type" label="Type" />
    <lull-datatableColumn id="expiration" label="Expiration" />
    <lull-datatableColumn id="created" label="Created" />
    <lull-datatableColumn :width="'55%'" id="actions" justifyContent="center">
      <span></span>
    </lull-datatableColumn>

    <template v-slot:created="{ row }">
      {{ formatDate(row.created) }}
    </template>

    <template v-slot:expiration="{ row }">
      {{ formatDate(row.expiration) }}
    </template>

    <template v-slot:actions="{ row }">
      <lull-button class="w-0.5" type="danger" @click="remove(row.id)">
        <lull-icon icon="fa-trash" />
      </lull-button>

      <lull-button class="w-0.5 ml-3" type="info" @click="edit(row)">
        <lull-icon icon="fa-edit" />
      </lull-button>
    </template>
  </lull-datatable>

  <div class="w-full mt-2 flex justify-end">
    <lull-button type="info" @click="showModal()">New Secret</lull-button>
  </div>

  <lull-modal v-model="modalVisible" width="50rem" :closableMask="false">
    <secret
      :action="action"
      :secret="selected"
      :clientId="clientId"
      @close="hideModal()"
      @refresh="refresh()"
    />
  </lull-modal>

  <confirm
    v-model="confirmationModal"
    :callback="confirmationCallback"
    message="Are you sure you want to delete this secret?"
  />
</template>

<script lang="ts">
import { ClientSecret } from '@/core/models/client/ClientSecret';
import { ManageAction } from '@/core/types/ManageAction';
import { useStore } from '@/store';
import { ClientAction } from '@/store/Clients/ClientModule';
import { computed, ComputedRef, defineComponent, onMounted, ref } from 'vue';
import Secret from './Secret.vue';
import { Confirm } from '@/core/components';

export default defineComponent({
  name: 'secrets',
  components: {
    secret: Secret,
    confirm: Confirm,
  },
  props: {
    clientId: { type: String, required: true },
  },
  setup(props) {
    const store = useStore();
    const selected = ref<Partial<ClientSecret>>();
    const loading: ComputedRef<boolean> = computed(
      () => store.getters['client/secretsLoadingState']
    );
    const secrets = ref<ClientSecret[]>([]);
    const modalVisible = ref<boolean>(false);
    const action = ref<ManageAction>(ManageAction.Create);
    const confirmationModal = ref<boolean>(false);
    const confirmationCallback = ref<Function | null>(null);

    function showModal(): void {
      modalVisible.value = true;
    }

    function hideModal(): void {
      selected.value = {
        id: 0,
        description: '',
        value: '',
        type: '',
        expiration: undefined,
        created: undefined,
      };
      action.value = ManageAction.Create;
      modalVisible.value = false;
    }

    async function getSecrets(): Promise<void> {
      const results = await store.dispatch(
        `client/${ClientAction.GetSecrets}`,
        props.clientId
      );
      if (results) {
        secrets.value = results;
      }
    }

    async function refresh(): Promise<void> {
      hideModal();
      await getSecrets();
    }

    function edit(row: ClientSecret): void {
      action.value = ManageAction.Edit;
      selected.value = row;
      showModal();
    }

    async function remove(id: number): Promise<void> {
      const cb = async (): Promise<void> => {
        const results = await store.dispatch(
          `client/${ClientAction.DeleteSecret}`,
          id
        );

        if (results) {
          await getSecrets();
        }
      };

      confirmationCallback.value = cb;
      confirmationModal.value = true;
    }

    function formatDate(d: string): string {
      if (!d) {
        return '';
      }

      const date = new Date(d);
      const newdate =
        date.getMonth() + 1 + '/' + date.getDate() + '/' + date.getFullYear();

      return newdate;
    }

    onMounted(async () => {
      await getSecrets();
    });

    return {
      selected,
      loading,
      secrets,
      modalVisible,
      action,
      showModal,
      hideModal,
      confirmationModal,
      confirmationCallback,
      refresh,
      edit,
      remove,
      formatDate,
    };
  },
});
</script>

